/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief USBҰ
//!
//!  ̧ق͋Lqq\ʂĉpBɎʂUSBҰ܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2007, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

/*_____ ݸٰ _____________________________________________________________*/

#include "config.h"
#include "conf_usb.h"

#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "usb_specific_request.h"
#if ((USB_DEVICE_SN_USE==ENABLE) && (USE_DEVICE_SN_UNIQUE==ENABLE))
#include "lib_mcu/flash/flash_drv.h"
#endif

/*_____ ϸ _________________________________________________________________*/

/*_____ ` ________________________________________________________________*/

// usb_user_device_descriptor
code S_usb_device_descriptor usb_dev_desc =
{
	sizeof(usb_dev_desc),
	DESCRIPTOR_DEVICE,
	Usb_write_word_enum_struc(USB_SPECIFICATION),
	DEVICE_CLASS,
	DEVICE_SUB_CLASS,
	DEVICE_PROTOCOL,
	EP_CONTROL_LENGTH,
	Usb_write_word_enum_struc(VENDOR_ID),
	Usb_write_word_enum_struc(PRODUCT_ID),
	Usb_write_word_enum_struc(RELEASE_NUMBER),
	MAN_INDEX,
	PROD_INDEX,
	SN_INDEX,
	NB_CONFIGURATION
};

// usb_user_configuration_descriptor FS
code S_usb_user_configuration_descriptor usb_conf_desc =
{
	{
		sizeof(S_usb_configuration_descriptor),
		DESCRIPTOR_CONFIGURATION,
		Usb_write_word_enum_struc(sizeof(S_usb_configuration_descriptor) \
								 +sizeof(S_usb_interface_descriptor)     \
								 +sizeof(S_usb_endpoint_descriptor)      \
								 +sizeof(S_usb_endpoint_descriptor)),
		NB_INTERFACE,
		CONF_NB,
		CONF_INDEX,
		CONF_ATTRIBUTES,
		MAX_POWER
	},
	{
		sizeof(S_usb_interface_descriptor),
		DESCRIPTOR_INTERFACE,
		INTERFACE_NB,
		ALTERNATE,
		NB_ENDPOINT,
		INTERFACE_CLASS,
		INTERFACE_SUB_CLASS,
		INTERFACE_PROTOCOL,
		INTERFACE_INDEX
	},
	{
		sizeof(S_usb_endpoint_descriptor),
		DESCRIPTOR_ENDPOINT,
		ENDPOINT_NB_2,
		EP_ATTRIBUTES_2,
		Usb_write_word_enum_struc(EP_SIZE_2),
		EP_INTERVAL_2
	},
	{
		sizeof(S_usb_endpoint_descriptor),
		DESCRIPTOR_ENDPOINT,
		ENDPOINT_NB_3,
		EP_ATTRIBUTES_3,
		Usb_write_word_enum_struc(EP_SIZE_3),
		EP_INTERVAL_3
	}
};

// usb_user_manufacturer_string_descriptor
code S_usb_manufacturer_string_descriptor usb_user_manufacturer_string_descriptor =
{
	sizeof(usb_user_manufacturer_string_descriptor),
	DESCRIPTOR_STRING,
	USB_MANUFACTURER_NAME
};

// usb_user_product_string_descriptor
code S_usb_product_string_descriptor usb_user_product_string_descriptor =
{
	sizeof(usb_user_product_string_descriptor),
	DESCRIPTOR_STRING,
	USB_PRODUCT_NAME
};

// usb_user_serial_number
#if (USB_DEVICE_SN_USE==ENABLE)
code S_usb_serial_number usb_user_serial_number =
{
#if (USE_DEVICE_SN_UNIQUE==ENABLE)
	sizeof(usb_user_serial_number)+4*SN_LENGTH,
	DESCRIPTOR_STRING
#else
	sizeof(usb_user_serial_number),
	DESCRIPTOR_STRING,
	USB_SERIAL_NUMBER
#endif
};
#endif

// usb_user_language_id
code S_usb_language_id usb_user_language_id =
{
	sizeof(usb_user_language_id),
	DESCRIPTOR_STRING,
	Usb_write_word_enum_struc(LANGUAGE_ID)
};
