/*̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief FAT޽
 *
 * ̧ق͋HɎgpFAT֐̑głB
 *
 * \author	Atmel Corporation	: http://www.atmel.com \n
 *			xFAQ			: http://support.atmel.no/
 *
 *****************************************************************************/

/* 쌠 (C) 2006-2008, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

/*_____ ݸٰ _____________________________________________________________*/
#include "conf_explorer.h"
#include "fs_com.h"
#include "fat.h"
#include LIB_MEM
#include LIB_CTRLACCESS

/*_____ ` ________________________________________________________________*/

/*_____ 錾 ________________________________________________________________*/

Bool	fat_select_filesystem				(U8 u8_fat_type, Bool b_MBR);
Bool	fat_write_MBR						(void);
Bool	fat_write_PBR						(Bool b_MBR);
Bool	fat_clean_zone						(Bool b_MBR);
Bool	fat_initialize_fat					(void);

//! \name tǂݏٰ݂ɂĎgpٰ
//! @{
void	fat_translatedate_number_to_ascii	(FS_STRING sz_date, PTR_CACHE ptr_date, Bool enable_ms);
void	fat_translate_number_to_ascii		(FS_STRING sz_ascii_number, U8 u8_size_number_ascii, U8 u8_nb_increment);
void	fat_translatedate_ascii_to_number	(const FS_STRING sz_date, PTR_CACHE ptr_date, Bool enable_ms);
U16		fat_translate_ascii_to_number		(const FS_STRING sz_ascii_number, U8 u8_size_number_ascii);
//! @}

//! \name ̧ٓ쐬̂Ɏgpٰ
//! @{
void	fat_create_long_name_entry			(FS_STRING sz_name, U8 u8_crc, U8 u8_id);
U8		fat_create_short_entry_name			(FS_STRING sz_name, FS_STRING short_name, U8 nb, Bool mode);
U8		fat_find_short_entry_name			(FS_STRING sz_name);
Bool	fat_entry_shortname_compare			(FS_STRING short_name);
U8		fat_check_name						(FS_STRING sz_name);
U8		fat_translate_char_shortname		(U8 character);
Bool	fat_alloc_entry_free				(U8 u8_nb_entry);
Bool	fat_garbage_collector_entry			(void);
//! @}

//! ̊֐͑Iײނ߰è ̧ (FAT12/16/32)𐘕t܂B
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_nav.u8_lun		tײނ
//!   fs_g_nav.u8_partition	t߰è݂(FS_MULTI_PARTITION=ENABLED̏ꍇ)
//! OUT:
//!   fs_g_nav				\̂XV
//! FS_MULTI_PARTITIONCӑI֎~ĂꍇA
//! ţٰ݂ тɂĎxŏ߰è݂I܂B<br>
//! @endverbatim
//!
Bool fat_mount (void)
{
	U8  u8_sector_size;
	U8  u8_tmp;
	U16 u16_tmp;
	U32 u32_tmp;

	// ٰ ިڸؑI
	fs_g_nav.u32_cluster_sel_dir = 0;
	// I̧قȂ
	fat_clear_entry_info_and_ptr();

	fs_g_nav_fast.u8_type_fat = FS_TYPE_FAT_UNM;
	fs_gu32_addrsector = 0;					// ؂̎n߂œǂݍ݊Jn

	// ײނp\
	if( !fat_check_device() )
		return FALSE;

	while(1)								 // L߰è݌
	{
		// 1ǂݍ
		if( !fat_cache_read_sector( TRUE ))
			return FALSE;

		// PBR/MBR[
		if ( (fs_g_sector[510] != FS_BR_SIGNATURE_LOW  )
		 &&  (fs_g_sector[511] != FS_BR_SIGNATURE_HIGH ) )
		{
			fs_g_status = FS_ERR_NO_FORMAT;
			return FALSE;
		}

		if ( 0 == fs_gu32_addrsector )
		{
			//** ŏ̾ȂAMBR\̌
			// xŏ߰è݂
#if (FS_MULTI_PARTITION == ENABLED)
			u16_tmp=0;						// "L߰è݂ȂB"ɏ
#endif
			for( u8_tmp=0 ; u8_tmp!=4 ; u8_tmp++ )
			{
				// ŏ̾MBRłȂ΂Ȃ炸AMBR߰èݓ
				if ( ((fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+0] == FS_PART_BOOTABLE             )||
					  (fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+0] == FS_PART_NO_BOOTABLE          )  )
				  && ((fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+4] == FS_PART_TYPE_FAT12           )||
					  (fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+4] == FS_PART_TYPE_FAT16_INF32M    )||
					  (fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+4] == FS_PART_TYPE_FAT16_SUP32M    )||
					  (fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+4] == FS_PART_TYPE_FAT16_SUP32M_BIS)||
					  (fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+4] == FS_PART_TYPE_FAT32           )||
					  (fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+4] == FS_PART_TYPE_FAT32_BIS       )) )
				{
					// L߰è݂
#if (FS_MULTI_PARTITION == ENABLED)
					if( u16_tmp == fs_g_nav.u8_partition )
						break;				// I߰è݂͗L
					u16_tmp++;
#else
					break;
#endif
				}
			}
			if( u8_tmp != 4 )
			{
				// ߰èݔ˕ψ8(Pʂ)߰è݈ʒu擾
				LSB0(fs_gu32_addrsector) = fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+8];
				LSB1(fs_gu32_addrsector) = fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+9];
				LSB2(fs_gu32_addrsector) = fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+10];
				LSB3(fs_gu32_addrsector) = fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(u8_tmp)+11];
				fs_gu32_addrsector *= mem_sector_size( fs_g_nav.u8_lun );
				continue;					// ߰è݂PBR
			}

			// MBRȂAPBR
#if (FS_MULTI_PARTITION == ENABLED)
			// ޲͕ł͂Ȃ1߰è݂܂B
			if ( 0 != fs_g_nav.u8_partition )
			{
				fs_g_status = FS_ERR_NO_PART;
				return FALSE;
			}
#endif
		}

		//** PBR\̌
		if ( (fs_g_sector[0] == 0xEB) &&			// PBR޲0
			 (fs_g_sector[2] == 0x90) &&			// PBR޲2
			((fs_g_sector[21] & 0xF0) == 0xF0) )	// PBR޲21:}޲
		{
			break;							// LPBR
		}
		// PBR
		fs_g_status = FS_ERR_NO_PART;
		return FALSE;
	}

	fs_g_status = FS_ERR_NO_SUPPORT_PART;	// ɂĎxȂ߰è

	// ̧ т̾eʂ擾(512޲ĒP)
	// ި Pʂ512޲ Pʂ֕ϊ
	u8_sector_size = HIGH_16_BPB_BytsPerSec/2;

	// BPB_SecPerClusǂݍ(P)
	fs_g_nav.u8_BPB_SecPerClus = U8_BPB_SecPerClus * u8_sector_size;

	//** FAT`("ʰ޳FAT"̎Z@)
	// FATeʎ擾(P)
	LSB( u16_tmp ) = LOW_16_BPB_FATSz16;
	MSB( u16_tmp ) = HIGH_16_BPB_FATSz16;
	if ( 0==u16_tmp )
	{
		LSB( u16_tmp ) = LOW0_32_BPB_FATSz32;
		MSB( u16_tmp ) = LOW1_32_BPB_FATSz32;
		// 傫FAT32̧͂ тɂĎx܂B
		if( (0 != LOW2_32_BPB_FATSz32 )
		 || (0 != LOW3_32_BPB_FATSz32 ) )
		{
			return FALSE;
		}
	}
	fs_g_nav.u16_fat_size = u16_tmp * u8_sector_size;

	// ߰èݓ̑擾
	if ( (0==LOW_16_BPB_TotSec16) && (0==HIGH_16_BPB_TotSec16) )
	{
		LSB0( u32_tmp ) = LOW0_32_BPB_TotSec32;
		LSB1( u32_tmp ) = LOW1_32_BPB_TotSec32;
		LSB2( u32_tmp ) = LOW2_32_BPB_TotSec32;
		LSB3( u32_tmp ) = LOW3_32_BPB_TotSec32;
	}
	else
	{
		LSB0( u32_tmp ) = LOW_16_BPB_TotSec16;
		LSB1( u32_tmp ) = HIGH_16_BPB_TotSec16;
		LSB2( u32_tmp ) = 0;
		LSB3( u32_tmp ) = 0;
	}
	u32_tmp *= u8_sector_size;				// ި Pʂ512޲ Pʂ֕ϊ

	// FAT̏I(FAT1xٰ ިڸ؂̎n)PBR̎nߊԂ(512޲ĒPʂ)ψʂvZ
	fs_g_nav.rootdir.seg.u16_pos = FS_NB_FAT * fs_g_nav.u16_fat_size;

	// ٰ ިڸؗeʂvZ(P)AFAT32͏0
	LSB( u16_tmp ) = LOW_16_BPB_RootEntCnt;
	MSB( u16_tmp ) = HIGH_16_BPB_RootEntCnt;
	fs_g_nav.rootdir.seg.u16_size = ((u16_tmp * FS_SIZE_FILE_ENTRY) + ((FS_512B*u8_sector_size)-1)) / (FS_512B*u8_sector_size);
	fs_g_nav.rootdir.seg.u16_size *= u8_sector_size;

	// \擾
	LSB( u16_tmp ) = LOW_16_BPB_ResvSecCnt;
	MSB( u16_tmp ) = HIGH_16_BPB_ResvSecCnt;
	// ̧ яʒu擾
	fs_g_nav.u16_offset_FSInfo = (u16_tmp-LOW_16_BPB_FSInfo)*u8_sector_size;
	u16_tmp *= u8_sector_size;				// 512޲ĒPʂŕϊꂽ\

	// FATڽvZ(512޲ĒP)
	fs_g_nav.u32_ptr_fat = fs_gu32_addrsector + u16_tmp;

	// ŏް ׽FAT̎nߊԂ(512޲ĒPʂ)ψʂvZ
	fs_g_nav.u32_offset_data = (FS_NB_FAT * (U32)fs_g_nav.u16_fat_size) + (U32)fs_g_nav.rootdir.seg.u16_size;

	// ް̈(׽=-gp)eʂvZ(512޲ĒP)
	u32_tmp -= ((U32)u16_tmp + fs_g_nav.u32_offset_data);

	// ް̸̈׽vZ
	// !!!œKu32_CountofCluster(512޲ĒP)/fs_g_nav.u8_BPB_SecPerClus(512޲ĒP & 2ׂ̂)
	for( u8_tmp = fs_g_nav.u8_BPB_SecPerClus; u8_tmp!=1 ; u8_tmp >>= 1 )
	{
		u32_tmp  >>= 1;						// ̌vZ͐؂̂Ċۂ
	}
	fs_g_nav.u32_CountofCluster = u32_tmp+2;	// 2̗\׽܂޸׽̍v

	// FAT`
	if (u32_tmp < FS_FAT12_MAX_CLUSTERS)
	{
		// FAT12
#if (FS_FAT_12 == DISABLED)
		return FALSE;
#endif
		fs_g_nav_fast.u8_type_fat = FS_TYPE_FAT_12;
	} else {
		if (u32_tmp < FS_FAT16_MAX_CLUSTERS)
		{
			// FAT16
#if (FS_FAT_16 == DISABLED)
			return FS_NO_SUPPORT_PART;
#endif
			fs_g_nav_fast.u8_type_fat = FS_TYPE_FAT_16;
		} else {
			// FAT32
#if (FS_FAT_32 == DISABLED)
			return FALSE;
#endif
			fs_g_nav_fast.u8_type_fat = FS_TYPE_FAT_32;
			// FAT32łٰ ިڸ؂ʂިڸ؂̂悤ŁA͸׽ꗗ܂B
			// ٰĂ̍ŏ̸׽ԍ擾
			LSB0( fs_g_nav.rootdir.u32_cluster ) = LOW0_32_BPB_RootClus;
			LSB1( fs_g_nav.rootdir.u32_cluster ) = LOW1_32_BPB_RootClus;
			LSB2( fs_g_nav.rootdir.u32_cluster ) = LOW2_32_BPB_RootClus;
			LSB3( fs_g_nav.rootdir.u32_cluster ) = LOW3_32_BPB_RootClus;
		}
	}

	return TRUE;
}

#if (FSFEATURE_WRITE_COMPLET == (FS_LEVEL_FEATURES & FSFEATURE_WRITE_COMPLET) )

//! \name ̫ϯ ٰ݂̐LԂ𐭓G邽߂̑Sϐ
_MEM_TYPE_SLOW_ U32 fs_s_u32_size_partition;

//! ̊֐݂͌ײނ̫ϯĂ܂B
//!
//! @param	u8_fat_type		̫ϯČ`I<br>
//!							FS_FORMAT_DEFAULT		̧ ѕײދԂɑ΂ǂFAT̫ϯ<br>
//!							FS_FORMAT_FAT			\(ި<2G޲)Ȃײނ̫ϯĂ̂FAT12܂FAT16gp܂B<br>
//!							FS_FORMAT_FAT32			\(ި>32M޲)Ȃײނ̫ϯĂ̂FAT32gp܂B<br>
//!							FS_FORMAT_NOMBR_FLAG	ިMRB]܂Ȃ(Ⴆ΁ACDxłFAT̫ϯ)ꍇɂ׸ނǉ܂B
//!
//! @return	FALSE			ُ̏ꍇA葽̏ڍׂɂ"fs_g_status"SlB
//! @return	TRUE			̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//! fs_g_nav.u8_lun			̧ϯĂײނB
//!
//! ٰ݂͕߰è݂̫ϯĂ邱ƂłAި߰èݗ̈܂ޏꍇA
//! ߰è݂͏ASĂިԂł̒P߰è݂ɂĒu܂B
//! @endverbatim
//!
Bool fat_format (U8 u8_fat_type)
{
	Bool b_MBR;
#if (FS_MULTI_PARTITION == ENABLED)
#error NOT SUPPORTED
	fs_g_nav.u8_partition = 0;
#endif

	// ײޗe(=ŌLBA)擾
	mem_read_capacity( fs_g_nav.u8_lun , &fs_s_u32_size_partition );

	if( u8_fat_type & FS_FORMAT_NOMBR_FLAG )
	{
		b_MBR = FALSE;
		u8_fat_type &= ~FS_FORMAT_NOMBR_FLAG;
		// ߰èݗe=ިe=ŌLBA+1
		fs_s_u32_size_partition++;
	}else{
		b_MBR = TRUE;
		// ߰èݗe=ިe-1=ŌLBA
	}

	// uɑ΂FAT`vZ
	if( !fat_select_filesystem( u8_fat_type , b_MBR ))
		return FALSE;

	// MBR(ŏ̾)
	if( b_MBR )
		if( !fat_write_MBR())
			return FALSE;

	// PBR
	if( !fat_write_PBR( b_MBR ))
		return FALSE;

	// \AFATAٰ ިڸ؋
	// :FAT32̗\BPB_FSInfo0Ɠߏ܂B
	if( !fat_clean_zone( b_MBR ))
		return FALSE;

	// FAT12̏
	if( !fat_initialize_fat())
		return FALSE;

	return fat_cache_flush();
}

//! \name ̫ϯĕ\\
typedef struct st_fs_format_table
{
	U32		u32_disk_size;
	U8		u8_SecPerClusVal;
} Fs_format_table;

//! FAT12p̫ϯĕ\
_CONST_TYPE_ Fs_format_table TableFAT12[] =
{
	{  4096, 1},							// ő2M޲Ă܂łިA512޲ ׽
	{  8192, 2},							// ő4M޲Ă܂łިA1K޲ ׽
	{ 16384, 4},							// ő8M޲Ă܂łިA2K޲ ׽
	{ 32680, 8},							// ő16M޲Ă܂łިA4K޲ ׽
};
/*
:̕\͗Ⴆ\Iɑ傫<16M޲Ăިɑ΂gpĂA
16M޲Ă傫ިeʗp̓܂݂܂B
̕\@́A̕\DiskSizëȂA܂͓
ިeʂɑ΂ĕ\̍ŏ̓TƂłB
̕\߂ɁABPB_RsvdSecCnt1ABPB_NumFATs2ABPB_RootEntCnt
512łȂ΂Ȃ܂B
*/

//! FAT16p̫ϯĕ\
_CONST_TYPE_ Fs_format_table TableFAT16[] =
{
	{ 8400, 0},								// ő4.1M޲ĂިASecPerClusValɑ΂0̒lُ͈ƊԈႦ܂B
	{ 32680, 2},							// ő16M޲ĂިA1K׽
	{ 262144, 4},							// ő128M޲ĂިA2K׽
	{ 524288, 8},							// ő256M޲ĂިA4K׽
	{ 1048576, 16},							// ő512M޲ĂިA8K׽
	// ̓_ȍ~FAT16ȂΎgp܂B
	{ 2097152, 32},							// ő1G޲ĂިA16K׽
	{ 4194304, 64},							// ő1G޲ĂިA32K׽
	{ 0xFFFFFFFF, 0}						// 2G޲Ă傫ȂǂިASecPerClusValɑ΂0̒lُ͈ƊԈႦ܂B
};
/*
:̕\͗Ⴆ\Iɑ傫<512M޲Ăިɑ΂gpĂA
512M޲Ă傫ިeʗp̓܂݂܂B
̕\@́A̕\DiskSizëȂA܂͓
ިeʂɑ΂ĕ\̍ŏ̓TƂłB
̕\߂ɁABPB_RsvdSecCnt1ABPB_NumFATs2ABPB_RootEntCnt
512łȂ΂Ȃ܂B
̒l̂ǂꂩႤƂ́AύXׂŏ̕\DiskSizelKvƂ
邩ꂸAȂθ׽FAT16ɑ΂ĒႭȂ蓾܂B
*/

//! FAT32p̫ϯĕ\
_CONST_TYPE_ Fs_format_table TableFAT32[] =
{
	{ 66600, 0},							// ő32.5M޲Ă܂łިASecPerClusValɑ΂0̒lُ͈ƊԈႦ܂B
	{ 532480, 1},							// ő260M޲Ă܂łިA5K׽
	{ 16777216, 8},							// ő8G޲Ă܂łިA4K׽
	{ 33554432, 16},						// ő16G޲Ă܂łިA8K׽
	{ 67108864, 32},						// ő32G޲Ă܂łިA16K׽
	{ 0xFFFFFFFF, 64}						// 32G޲Ă傫ިA32K׽
};
/*
:̕\͗Ⴆ\Iɑ傫<512M޲Ăިɑ΂gpĂA
512M޲Ă傫ިeʗp̓܂݂܂B
̕\@́A̕\DiskSizëȂA܂͓
ިeʂɑ΂ĕ\̍ŏ̓TƂłB
̕\߂ɁABPB_RsvdSecCnt1ABPB_NumFATs2ABPB_RootEntCnt
512łȂ΂Ȃ܂B
̒l̂ǂꂩႤƂ́AύXׂŏ̕\DiskSizelKvƂ
邩ꂸAȂθ׽FAT32ɑ΂ĒႭȂ蓾܂B
*/

//! \name ̫ϯ ٰ݂ɂĎgpٰ
//! @{

//! ̊֐͎gpFAT`vZ܂B
//!
//! @param	u8_fat_type	̫ϯĂ̌`I<br>
//!						FS_FORMAT_DEFAULT	̧ ѕײދԂɑ΂ĂǂFAT̫ϯĂI<br>
//!						FS_FORMAT_FAT		\(ި<2G޲)ȂAײނ̫ϯĂ̂FAT12܂FAT16gp܂B<br>
//!						FS_FORMAT_FAT32		\(ި>32M޲)ȂAײނ̫ϯĂ̂FAT32gp܂B<br>
//! @param	b_MBR		TRUE	ިMBR܂݂܂B
//!
//! @return	FALSE		ُ̏ꍇA葽̏ڍׂĂ"fs_g_status"SlB
//! @return	TRUE		̑
//!
//! @verbatim
//! FAT`AFATʒuAFATeʂvZ
//! @endverbatim
//!
Bool fat_select_filesystem (U8 u8_fat_type, Bool b_MBR)
{
	U8 u8_i;
	U8 u8_tmp = 0;
	U16  u16_tmp, u16_tmp2;
	Fs_format_table _CONST_TYPE_ *ptr_table;

	if( (FS_FORMAT_FAT   != u8_fat_type )
	 && (FS_FORMAT_FAT32 != u8_fat_type ) )
	{
		// ̫ϯĂȂAǂFAT`I
		if( (((U32)512*1024*1024)/FS_512B) >= fs_s_u32_size_partition  )
		{
			u8_fat_type = FS_FORMAT_FAT;
		} else {
			u8_fat_type = FS_FORMAT_FAT32;
		}
	}

	//** IꂽFAT`mF
	if(FS_FORMAT_FAT == u8_fat_type )
	{
		if( (((U32)15*1024*1024)/FS_512B) >= fs_s_u32_size_partition  )
		{
			// FAT12̫ϯ
			fs_g_nav_fast.u8_type_fat = FS_TYPE_FAT_12;
			u8_i = sizeof(TableFAT12);
			ptr_table = TableFAT12;
		}else{
			// FAT16̫ϯ
			fs_g_nav_fast.u8_type_fat = FS_TYPE_FAT_16;
			u8_i = sizeof(TableFAT16);
			ptr_table = TableFAT16;
		}
	}
	else
	{	// FAT32̫ϯ
		fs_g_nav_fast.u8_type_fat = FS_TYPE_FAT_32;
		u8_i = sizeof(TableFAT32);
		ptr_table = TableFAT32;
	}
	for(  ; u8_i!=0 ; u8_i-- )
	{
		if( fs_s_u32_size_partition <= ptr_table->u32_disk_size )
		{
			// (Pʂ)׽eʎ擾
			fs_g_nav.u8_BPB_SecPerClus = ptr_table->u8_SecPerClusVal;
			break;
		}
		ptr_table++;
	}
	if(0 == fs_g_nav.u8_BPB_SecPerClus)
	{
		fs_g_status = FS_ERR_BAD_SIZE_FAT;	// ިeʂ͑IFAT`ɂĎx܂B
		return FALSE;
	}

	//** FAT̑傫vZ
	// PBRڽvZ
	if( b_MBR )
		fs_g_nav.u32_ptr_fat = 1;			// MBR
	else
		fs_g_nav.u32_ptr_fat = 0;			// MBRȂ

	if( Is_fat12 )
	{	// FAT12
		fs_g_nav.u32_ptr_fat += 1;			// FATڽ=PBRڽ+1
		// FAT12̑傫̑SẲ\s
		fs_g_nav.u16_fat_size=1;
		while(1)
		{
			if( 12 < fs_g_nav.u16_fat_size)		// FAT12`Ԃł(Pʂ)őFATe(=0xFFE*1.5/FS_512B)
			{
				fs_g_status = FS_ERR_BAD_SIZE_FAT;	// ިeʂ͑IFAT`ɂĎx܂B
				return FALSE;
			}
			// ް̑傫ɑΉ׽
			// : PBRvZȂ߂-1
			u16_tmp  = ((fs_s_u32_size_partition -1 - (fs_g_nav.u16_fat_size *2)) / fs_g_nav.u8_BPB_SecPerClus)+2;
			u16_tmp2 = (fs_g_nav.u16_fat_size *FS_512B *2) / 3;
			if( u16_tmp <= u16_tmp2 )
				break;						// FATeOK

			fs_g_nav.u16_fat_size++;
		}
	}
	else
	{
		if( Is_fat32 )
		{  // FAT32
			fs_g_nav.u32_ptr_fat += 32;		// FATڽ=PBRڽ+BPB_ResvSecCnt
			// RootDirSectors = ((BPB_RootEntCnt * 32) + (BPB_BytsPerSec  1)) / BPB_BytsPerSec;
			//                = (FS_512B-1) / FS_512B = 0
			// TmpVal1        = DskSize  (BPB_ResvdSecCnt + RootDirSectors);
			//                = fs_s_u32_size_partition - (32 + 0)
			//                = fs_s_u32_size_partition - u8_tmp
			u8_tmp = 32;
			// TmpVal2        = ((256 * BPB_SecPerClus) + BPB_NumFATs )/2;
			//                = ((((U16)fs_g_nav.u8_BPB_SecPerClus)<<8) + 2) >> 1;
			//                = (((U16)fs_g_nav.u8_BPB_SecPerClus)<<7) + 1;
			//                = u16_tmp
			u16_tmp = (((U16)fs_g_nav.u8_BPB_SecPerClus)<<7) + 1;
			// BPB_FATSz16    = 0;
			// BPB_FATSz32    = FATSz;
		}
		if( Is_fat16 )
		{  // FAT16
			fs_g_nav.u32_ptr_fat += 1;		// FATڽ=PBRڽ+BPB_ResvSecCnt
			// RootDirSectors = ((BPB_RootEntCnt * 32) + (BPB_BytsPerSec  1))  / BPB_BytsPerSec
			//                = ((512            * 32) + (FS_512B-1)) / FS_512B
			//                = 32
			// TmpVal1        = DskSize  (BPB_ResvdSecCnt + RootDirSectors);
			//                = fs_s_u32_size_partition - (1 + 32)
			//                = fs_s_u32_size_partition - u8_tmp
			u8_tmp = 33;
			// TmpVal2        = ((256 * BPB_SecPerClus) + BPB_NumFATs )/2;
			//                = (((U16)fs_g_nav.u8_BPB_SecPerClus)<<8) + 2;
			//                = u16_tmp
			MSB(u16_tmp) = fs_g_nav.u8_BPB_SecPerClus;
			LSB(u16_tmp) = 2;
		}
		// FATSz = (TMPVal1 + TmpVal2  1) / TmpVal2;
		fs_g_nav.u16_fat_size = (fs_s_u32_size_partition -u8_tmp +u16_tmp -1) / u16_tmp;
	}

	return TRUE;
}

//! ̊֐MBRɏ܂B
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
Bool fat_write_MBR (void)
{
	U8 u8_i = 0;

	// ؂̎n߂œؾį
	fs_gu32_addrsector = 0;
	if( !fat_cache_read_sector( FALSE ))
		return FALSE;
	fat_cache_mark_sector_as_dirty();
	fat_cache_clear();

	// MBR[
	fs_g_sector[510] = FS_BR_SIGNATURE_LOW;
	fs_g_sector[511] = FS_BR_SIGNATURE_HIGH;

	// MBR߰èݓ
	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0) +0] = FS_PART_NO_BOOTABLE;	// ߰è
	// :ނͯނ0ŊJnAl1ŊJn
//	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0) +1] = 0;	// ߰è݊Jnͯ(0)
	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0) +2] = 2;	// ߰è݊Jn̾(2=MBRɑ΂Ď)Ƽ(0)
//	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0) +3] = 0;

	// ߰è݌`
	if( Is_fat32 )
	{	// FAT32
		u8_i = FS_PART_TYPE_FAT32;
	}
	if( Is_fat16 )
	{	// FAT16
		if( fs_s_u32_size_partition < (32L*1024*(1024/FS_512B)) )
		{	// ި<32M޲
			u8_i = FS_PART_TYPE_FAT16_INF32M;
		}else{
			u8_i = FS_PART_TYPE_FAT16_SUP32M;
		}
	}
	if( Is_fat12 )
	{	// FAT12
		u8_i = FS_PART_TYPE_FAT12;
	}

	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0) +4] = u8_i;

	// ߰èݍŌͯ
	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0) +5] = (LSB1(fs_s_u32_size_partition)<<2) + (LSB0(fs_s_u32_size_partition)>>6);
	// ߰èݍŌ̾Ƽ
	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0) +6] = (LSB1(fs_s_u32_size_partition)&0xC0) + (LSB0(fs_s_u32_size_partition)&0x3F);
	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0) +7] = LSB2(fs_s_u32_size_partition);

	// ψ(̾)8()߰è݈ʒu
	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0)+ 8] = 0x01;
//	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0)+ 9] = 0x00;
//	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0)+10] = 0x00;
//	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0)+11] = 0x00;
	// ߰èݓ̾(=e-1MBR=read_capacityɂĕԂŌLBA)
	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0)+12] = LSB0(fs_s_u32_size_partition);
	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0)+13] = LSB1(fs_s_u32_size_partition);
	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0)+14] = LSB2(fs_s_u32_size_partition);
	fs_g_sector[FS_MBR_OFFSET_PART_ENTRY(0)+15] = LSB3(fs_s_u32_size_partition);

	return TRUE;
}

//! \name fat_write_PBR()ٰݗp萔
_CONST_TYPE_ U8 const_header_pbr[] =
{													   ψ
	0xEB,0,0x90,									// 00`02: ްĔ׸ޒǉ
	'M','S','W','I','N','4','.','1',				// 03`11: OEMǉȂ
	FS_512B & 0xFF, FS_512B >>8,					// 11`12: ޲Ăǉ
	0,												// 13	 : ׽ɂ龸ǉ
	0,0,											// 14`15: \ǉ(œKɂĂ͎̒iKB)
	2,												// 16	 : FATǉ
	0,0,											// 17`18: ٰēǉ(FAT32=0AFAT16=512)
	0,0,
	FS_PART_NO_REMOVE_MEDIA,						// 21	 : }޲
	0,0,
	0x3F,0,											// 24`25: ׯ̾(MBRɑ΂ĂǂłǂȂ΂Ȃ炸A܂ͯޓ̍ő徸=0x3F=6ޯ)
	0,0,											// 26`27: ͯސ
	1												// 28`31: B
};
_CONST_TYPE_ U8 const_tail_pbr[] =					// FAT16ŕψ36AFAT32ŕψ64
{
	FS_PART_HARD_DISK,								// ײޔԍ
	0,												// (\,Windows NTɂĎgp)
	FS_BOOT_SIGN,									// gްĎ[
	0,0,0,0,										// حID
	'N','O',' ','N','A','M','E',' ',' ',' ',' ',	// ح (11);
	'F','A','T',' ',' ',' ',' ',' ',				// ASCIIłFAT`(8);
};

//! \name "FAT32 FSInfo Sector"̒萔
//! @{
_CONST_TYPE_ U8 const_FSI_LeadSig[] =
{
	0x52,0x52,0x61,0x41						//! ψ00`04: ͎[擱܂B
};
_CONST_TYPE_ U8 const_FSI_StrucSig[] =
{
	0x72,0x72,0x41,0x61						//! ψ484`487: [
};
//! @}

//! ̊֐PBR܂B
//!
//! @param	b_MBR	TRUE	ިMBR܂
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
Bool fat_write_PBR (Bool b_MBR)
{
	U16 u16_tmp;

	//** PBRž 
	if( b_MBR )
		fs_gu32_addrsector = 1;
	else
		fs_gu32_addrsector = 0;

	if( !fat_cache_read_sector( FALSE ))
		return FALSE;
	fat_cache_mark_sector_as_dirty();
	fat_cache_clear();

	//** FATFAT32p̒萔ƕϐ̏
	memcpy_code2ram( fs_g_sector, const_header_pbr , sizeof(const_header_pbr) );
	// PBR[
	fs_g_sector[510] = FS_BR_SIGNATURE_LOW;
	fs_g_sector[511] = FS_BR_SIGNATURE_HIGH;

	// ψ13A׽ɂ龸ǉ
	otherwisefs_g_sector[13] = fs_g_nav.u8_BPB_SecPerClus;
	// ψ26`27A擪
	fs_g_sector[26] = (LSB1(fs_s_u32_size_partition)<<2) + (LSB0(fs_s_u32_size_partition)>>6);

	//** FAT16FAT32Ɉˑ萔ƕϐ̏
	// ψ36AFAT16FAT32ō\̋Ԃ̈Ⴂ܂B
	// ψ39`42܂67`70AحID͎gp܂B
	// ψ43`53܂71`81, ح 
	// ψ54`61܂82`89, ̧ ь`
	if( Is_fat32 )
	{
		memcpy_code2ram( &fs_g_sector[64], const_tail_pbr, sizeof(const_tail_pbr) );
	}else{
		memcpy_code2ram( &fs_g_sector[36], const_tail_pbr, sizeof(const_tail_pbr) );
	}

	u16_tmp = fs_g_nav.u16_fat_size;		// ލœK̂߂ɍŏްԓ̒lۑ
	if( Is_fat32 )
	{
		// ψ14`15A\ǉAFAT32=32
		fs_g_sector[14] = 32;
		// ψ17`18AٰēǉAFAT32=0
		// ψ36`39A32ޯFATe
		LOW0_32_BPB_FATSz32 = LSB(u16_tmp);
		LOW1_32_BPB_FATSz32 = MSB(u16_tmp);
		// ψ40`41Ag׸(SFAT͋=0)
		// ψ42`43, ̧ єŔԍ(0:0=0)
		// ψ44`47Aٰ ׽(ŏ̋󂫸׽=2)
		fs_g_sector[44]= 2;
		// ψ48`49A̧ я(ʏ1)
//		fs_g_sector[48]= 0;
		// ψ50`51Aޯ ް (ʏ6)
//		fs_g_sector[50]= 0;
		// ψ52`63A(\)
		// ψ54`61A̧ ь`
		fs_g_sector[85]='3';
		fs_g_sector[86]='2';
	}
	else
	{
		// FAT12܂FAT16
		// ψ14`15A\ǉAFAT=1
		fs_g_sector[14] = 1;
		// ψ17`18AٰēǉAFAT=512
//		fs_g_sector[17] = 512&0xFF;
		fs_g_sector[18] = 512>>8;

		// ψ22`23A16ޯFATe
		LOW_16_BPB_FATSz16  = LSB(u16_tmp);
		HIGH_16_BPB_FATSz16 = MSB(u16_tmp);
		// ψ54`61A̧ ь`
		fs_g_sector[57]='1';
		if( Is_fat12 )
		{
			fs_g_sector[58]='2';
		}else{
			fs_g_sector[58]='6';
		}
	}

	// ߰èݓྸ(=e-1MBR=read_capacityɂĕԂŌLBA)
	if( ( Is_fat32 )
	 || ((0x10000-1) <= fs_s_u32_size_partition) )
	{
		// FAT32܂ި>32M޲
		// ψ32`35A߰èݓ̾(32ޯĒl)
		fs_g_sector[32] = LSB0(fs_s_u32_size_partition);
		fs_g_sector[33] = LSB1(fs_s_u32_size_partition);
		fs_g_sector[34] = LSB2(fs_s_u32_size_partition);
		fs_g_sector[35] = LSB3(fs_s_u32_size_partition);
	}
	else
	{
		// ψ19`20A߰èݓ̾(16ޯĒl)
		fs_g_sector[19] = LSB0(fs_s_u32_size_partition);
		fs_g_sector[20] = LSB1(fs_s_u32_size_partition);
	}

	if( Is_fat32 )
	{
		// FAT32 ̧ я
		if( !fat_write_fat32_FSInfo( 0xFFFFFFFF ))
			return FALSE;
	}
	return TRUE;
}
//! @}

#ifdef  FS_FAT_32
//! ̊֐͑IꂽFAT32߰è݂ŋ󂫋Ԑ܂B
//!
//! ُ̏ꍇ"fs_g_status"SlǂłB
//!  FS_ERR_HW				ʰ޳ ײވُ
//!  FS_ERR_HW_NO_PRESENT	us
//!  FS_LUN_WP				ײނ͓ǂݍݐp
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
Bool fat_write_fat32_FSInfo (U32 u32_nb_free_cluster)
{
	// 
	fs_gu32_addrsector = fs_g_nav.u32_ptr_fat - fs_g_nav.u16_offset_FSInfo;

	if( !fat_cache_read_sector( FALSE ))
		return FALSE;
	fat_cache_mark_sector_as_dirty();
	fat_cache_clear();

	// 𖞂
	// ψ00`04A͎[擱܂B
	memcpy_code2ram( &fs_g_sector[0], const_FSI_LeadSig, sizeof(const_FSI_LeadSig) );
	// ψ004`483A(\A0Ŗ܂B)
	// ψ484`487A[
	memcpy_code2ram( &fs_g_sector[484], const_FSI_StrucSig, sizeof(const_FSI_StrucSig) );
	// ψ488`491A󂫸׽(ɂĒlȂ)
	fs_g_sector[488] = LSB0(u32_nb_free_cluster);
	fs_g_sector[489] = LSB1(u32_nb_free_cluster);
	fs_g_sector[490] = LSB2(u32_nb_free_cluster);
	fs_g_sector[491] = LSB3(u32_nb_free_cluster);
	// ψ492-495Aײނ󂫸׽Tn߂׽ԍ(ɂĒlȂ)B
	memset( &fs_g_sector[492] , 0xFF , 4 );
	// ψ496`509A(\A0Ŗ܂B)
	// ψ510`511A[
	fs_g_sector[510] = FS_BR_SIGNATURE_LOW;
	fs_g_sector[511] = FS_BR_SIGNATURE_HIGH;
	return TRUE;
}

//! ̊֐͑IFAT32߰è݂ł̋󂫋ԂԂ܂B
//!
//! @return	󂫋Ԑ(0xFFFFFFFF̏ꍇA̧ яŗp\ȒlȂ)
//!
U32 fat_read_fat32_FSInfo (void)
{
	U32 u32_nb_free_cluster;

	// FAT32̧ яǂݍ
	fs_gu32_addrsector = fs_g_nav.u32_ptr_fat - fs_g_nav.u16_offset_FSInfo;
	if( !fat_cache_read_sector( TRUE ))
		return 0xFFFFFFFF;

	//* [
	// ψ510`511A[
	if( fs_g_sector[510] != FS_BR_SIGNATURE_LOW )
		return 0xFFFFFFFF;
	if( fs_g_sector[511] != FS_BR_SIGNATURE_HIGH)
		return 0xFFFFFFFF;
	// ψ00`04A͎[U܂B
	if( 0 != memcmp_code2ram( &fs_g_sector[0], const_FSI_LeadSig, sizeof(const_FSI_LeadSig) ))
		return 0xFFFFFFFF;
	// ψ004`483A(\A0Ŗ܂B)
	// ψ484`487A[
	if( 0 != memcmp_code2ram( &fs_g_sector[484], const_FSI_StrucSig, sizeof(const_FSI_StrucSig)) )
		return 0xFFFFFFFF;

	//* lǂݍ
	// ψ488`491A󂫸׽
	LSB0(u32_nb_free_cluster) = fs_g_sector[488];
	LSB1(u32_nb_free_cluster) = fs_g_sector[489];
	LSB2(u32_nb_free_cluster) = fs_g_sector[490];
	LSB3(u32_nb_free_cluster) = fs_g_sector[491];
	return u32_nb_free_cluster;
}
#endif // FS_FAT_32

//! ̊֐͗\AFATAٰ ިڸ؋Yɂ܂B
//!
//! @param	b_MBR	TRUE	ިMBR܂
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
Bool fat_clean_zone (Bool b_MBR)
{
	U16 u16_nb_sector_clean;

	// Oɓj
	if( !fat_cache_flush())
		return FALSE;
	fat_cache_clear();

	// :̋PBŘɊi[Čp܂B
	// PBRɊJn
	if( b_MBR )
	{
		fs_gu32_addrsector = 2;				// MBRPBRɔ
	}else{
		fs_gu32_addrsector = 1;				// PBRɂ(MBR쐬Ȃ)
	}

	// \񂳂ꂽ̗eʂٰĂ̗eʂvZ
	if( Is_fat32 )
	{	// FAT32
		fs_gu32_addrsector++;				// FAT32̧ я֔
		// ٰėe=׽eAND\񂳂ꂽ=32-2(2=PBR+FSInfo)
		u16_nb_sector_clean = fs_g_nav.u8_BPB_SecPerClus + 30;
	}
	else
	{	// FAT12܂FAT16
		// ٰėe=512=32AND\񂳂ꂽ=1-1(PBR)
		u16_nb_sector_clean = 32;
	}
	u16_nb_sector_clean += (fs_g_nav.u16_fat_size*2);	// FATeʒǉ

	// JԂ
	for( ; u16_nb_sector_clean!=0; u16_nb_sector_clean-- )
	{
		if( !fat_cache_read_sector( FALSE ))
			return FALSE;
		fat_cache_mark_sector_as_dirty();
		fs_gu32_addrsector++;
	}
	return TRUE;
}

//! \name fat_initialize_fat()ٰݗp萔
//! @{
_CONST_TYPE_ U8 const_header_fat12[] =
{
	0xF8,0xFF,0xFF								// \׽0&1
};
_CONST_TYPE_ U8 const_header_fat16[] =
{
	0xF8,0xFF,0xFF,0xFF							// \׽0&1
};
_CONST_TYPE_ U8 const_header_fat32[] =
{
	0xF8,0xFF,0xFF,0x0F,0xFF,0xFF,0xFF,0x0F,	// \׽0&1
	0xFF,0xFF,0xFF,0x0F							// ٰ ިڸؗp\׽2
};
//! @}

//! ̊֐FAT 12܂B
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
Bool fat_initialize_fat (void)
{
	// ؂̎n߂œؾ
	fs_gu32_addrsector = fs_g_nav.u32_ptr_fat;
	if( !fat_cache_read_sector( FALSE ))
		return FALSE;
	fat_cache_mark_sector_as_dirty();

	if( Is_fat32 )
	{
		memcpy_code2ram( fs_g_sector, const_header_fat32, sizeof(const_header_fat32) );
	}
	if( Is_fat16 )
	{
		memcpy_code2ram( fs_g_sector, const_header_fat16, sizeof(const_header_fat16) );
	}
	if( Is_fat12 )
	{
		memcpy_code2ram( fs_g_sector, const_header_fat12, sizeof(const_header_fat12) );
	}

	// FAT 1̐擪FAT 2̐擪ɕ
	fs_gu32_addrsector = fs_g_nav.u32_ptr_fat + fs_g_nav.u16_fat_size;
	if( !fat_cache_read_sector( FALSE ))
		return FALSE;
	fat_cache_mark_sector_as_dirty();
	return TRUE;
}

//! ̊֐ײނŒʔԂǂ݂܂͏܂B
//!
//! @param	b_action	Iт܂(FS_SN_READ܂FS_SN_WRITE)B
//! @param	a_u8_sn		ʔԂi[܂͎擾z(U8[4])
//!
//! @return	FALSE		ُ̏ꍇA葽ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE		̑
//!
Bool fat_serialnumber (Bool b_action, U8 _MEM_TYPE_SLOW_ *a_u8_sn)
{
	// PBRڽvZ
	if ( Is_fat12 || Is_fat16 )
	{	// FAT12FAT16(BPB_ResvSecCnt1ɓȂ΂Ȃ܂B)
		fs_gu32_addrsector = fs_g_nav.u32_ptr_fat-1;
	}
	else
	{	// FAT32(BPB_ResvSecCnt32ɓȂ΂Ȃ܂B)
		fs_gu32_addrsector = fs_g_nav.u32_ptr_fat-32;
	}
	// PBRǂݍ
	if( !fat_cache_read_sector( TRUE ))
		return FALSE;

	// ʔԂ͋tɊi[܂B
	if( b_action == FS_SN_READ )
	{
		// ʔԓǂݍ
		a_u8_sn[0] = fs_g_sector[42];
		a_u8_sn[1] = fs_g_sector[41];
		a_u8_sn[2] = fs_g_sector[40];
		a_u8_sn[3] = fs_g_sector[39];
		return TRUE;
	}else{
		// ʔԏ
		fs_g_sector[42] = a_u8_sn[0];
		fs_g_sector[41] = a_u8_sn[1];
		fs_g_sector[40] = a_u8_sn[2];
		fs_g_sector[39] = a_u8_sn[3];
		fat_cache_mark_sector_as_dirty();
		return fat_cache_flush();
	}
}

//! ̊֐߰è݂قǂ݂܂͏܂B
//!
//! @param	b_action	I(FS_LABEL_READ܂FS_LABEL_WRITE)
//! @param	sz_label	يi[̂(ŏ11޲)܂͐VKَ擾̂(ő11޲)ASCII
//!
//! @return	FALSE		ُ̏ꍇA葽ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE		̑
//!
Bool fat_entry_label (Bool b_action, FS_STRING sz_label)
{
	PTR_CACHE ptr_entry;
	U8 u8_pos_name;
	U8 u8_char;

	ptr_entry = fat_get_ptr_entry();

	if( FS_LABEL_READ == b_action)
	{
		if( FS_ENTRY_END == ptr_entry[0] )	// ިڸ؂̏I
		{
			fs_g_status = FS_ERR_ENTRY_EMPTY;
			return FALSE;
		}
		if( FS_ATTR_VOLUME_ID != ptr_entry[11])		//  قȂ
		{
			fs_g_status = FS_ERR_ENTRY_BAD;
			return FALSE;
		}
		if( NULL == sz_label )
			return TRUE;
		for( u8_pos_name=0; u8_pos_name<11; u8_pos_name++ )
		{
			u8_char = *ptr_entry;
			if( 0x20 == u8_char )
				u8_char = 0;
			*sz_label = u8_char;
			if( 0 == u8_char )
				return TRUE;				// ǂ܂ꂽ
			ptr_entry++;
			sz_label++;
		}
		*sz_label = 0;
		return TRUE;
	}

	if( FS_LABEL_WRITE == b_action)
	{
		// ܂ٓł݂ٔF
		if( FS_ENTRY_END != ptr_entry[0] )	// ިڸ؂̏I
		{
			if( FS_ATTR_VOLUME_ID != ptr_entry[11])		//  قȂ
			{
				fs_g_status = FS_ERR_ENTRY_BAD;
				return FALSE;
			}
		}
		if( 0 == *sz_label )
		{
			fs_g_status = FS_ERR_NAME_INCORRECT;
			return FALSE;
		}
		ptr_entry[11] = FS_ATTR_VOLUME_ID;
		for( u8_pos_name=0; u8_pos_name<11; u8_pos_name++ )
		{
			u8_char = *sz_label;
			if( ('a'<=u8_char) && (u8_char<='z') )
			{
				u8_char -= ('a'-'A');		// 啶ɕύX
			}
			if( 0 == u8_char )
			{
				u8_char = 0x20;
			}
			*ptr_entry = u8_char;
			ptr_entry++;
			if( 0x20 == u8_char )
				continue;
			sz_label++;
		}
		fat_cache_mark_sector_as_dirty();
		return fat_cache_flush();
	}
	return FALSE;							// ߲قł̌x폜邽
}
#endif // FS_LEVEL_FEATURES

#if (FSFEATURE_WRITE_COMPLET == (FS_LEVEL_FEATURES & FSFEATURE_WRITE_COMPLET))
//! ̊֐ިڸ؏܂B
//!
//! @return	FALSE	ُ̏ꍇA葽ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_seg.u32_addr	ިڸ؂̸׽l
//! OUT:
//!   ިڸ ްž XV
//! @endverbatim
//!
Bool fat_initialize_dir (void)
{
	U8 u8_i;

	// ިڸ؂ɑΉ׽
	if( !fat_clear_cluster())
		return FALSE;
	fat_cache_mark_sector_as_dirty();
	// ŁA͸׽̐擪

	// "."쐬A͂ꎩgwިڸ؂łB
	fs_g_sector[0]='.';
	for( u8_i=1 ; u8_i<11 ; u8_i++ )
		fs_g_sector[u8_i]=' ';
	fs_g_sector[11]=FS_ATTR_DIRECTORY;
	fs_g_sector[26]= LSB0( fs_g_nav_entry.u32_cluster );
	fs_g_sector[27]= LSB1( fs_g_nav_entry.u32_cluster );
	fs_g_sector[20]= LSB2( fs_g_nav_entry.u32_cluster );
	fs_g_sector[21]= LSB3( fs_g_nav_entry.u32_cluster );
	// ".."쐬A͐eިڸ؂̎n߂̸׽w܂B
	fs_g_sector[FS_SIZE_FILE_ENTRY+0]='.';
	fs_g_sector[FS_SIZE_FILE_ENTRY+1]='.';
	for( u8_i=2 ; u8_i<11 ; u8_i++ )
		fs_g_sector[FS_SIZE_FILE_ENTRY+u8_i]=' ';
	fs_g_sector[FS_SIZE_FILE_ENTRY+11]=FS_ATTR_DIRECTORY;
	fs_g_sector[FS_SIZE_FILE_ENTRY+26]= LSB0( fs_g_nav.u32_cluster_sel_dir );
	fs_g_sector[FS_SIZE_FILE_ENTRY+27]= LSB1( fs_g_nav.u32_cluster_sel_dir );
	fs_g_sector[FS_SIZE_FILE_ENTRY+20]= LSB2( fs_g_nav.u32_cluster_sel_dir );
	fs_g_sector[FS_SIZE_FILE_ENTRY+21]= LSB3( fs_g_nav.u32_cluster_sel_dir );

	return TRUE;
}
#endif // FS_LEVEL_FEATURES

//! ̊֐͓tɂĂ̏ǂ݂܂B
//!
//! @param	type_date	t`I(FS_DATE_LAST_WRITE܂FS_DATE_CREATION)
//! @param	sz_date		ti[\<br>
//!						i[`(ASCII)="YYYYMMDDHHMMSSMS"=N,,,,,b,ms
//!
void fat_get_date (FS_STRING sz_date, Bool type_date)
{
	PTR_CACHE ptr_entry;

	ptr_entry = fat_get_ptr_entry();
	if( FS_DATE_LAST_WRITE == type_date )
	{
		fat_translatedate_number_to_ascii( sz_date , &ptr_entry[22] , FALSE );
	}
	else
	{
		fat_translatedate_number_to_ascii( sz_date , &ptr_entry[13] , TRUE );
	}
}

//! ̊֐͓tFATlASCIIɕϊ܂B
//!
//! @param	sz_date		ti[\<br>
//!						i[`(ASCII)="YYYYMMDDHHMMSSMS"=N,,,,,b,ms
//! @param	ptr_date	̓t߲
//! @param	enable_ms	TRUE	ms̈ϊ
//!
void fat_translatedate_number_to_ascii (FS_STRING sz_date, PTR_CACHE ptr_date, Bool enable_ms)
{
	FS_STRING ptr_string_date;
	U8 u8_i;
	U8 msb_date, lsb_date, msb_time, lsb_time, u8_ms = 0;

	// tƎԂ̓lǂݍ
	if( enable_ms )
	{
		u8_ms = *ptr_date;
		ptr_date++;
	}
	lsb_time = *ptr_date;
	ptr_date++;
	msb_time = *ptr_date;
	ptr_date++;
	lsb_date = *ptr_date;
	ptr_date++;
	msb_date = *ptr_date;

	// "1980000000000000"(N=1980Ƒ0)ŕ񏉊
	ptr_string_date = sz_date;
	*ptr_string_date = '1';
	ptr_string_date++;
	*ptr_string_date = '9';
	ptr_string_date++;
	*ptr_string_date = '8';
	ptr_string_date++;
	for( u8_i=(15-2) ; u8_i!=0 ; u8_i-- )
	{
		*ptr_string_date = '0';
		ptr_string_date++;
	}

	// N擾
	fat_translate_number_to_ascii( sz_date, 4 , msb_date>>1 );

	// 擾
	fat_translate_number_to_ascii( &sz_date[4] , 2 , ((msb_date & 0x01)<<3) + (lsb_date>>5) );

	// 擾
	fat_translate_number_to_ascii( &sz_date[6] , 2 , lsb_date & 0x1F );

	// 擾
	fat_translate_number_to_ascii( &sz_date[8] , 2 , msb_time >> (11-8) );

	// 擾
	fat_translate_number_to_ascii( &sz_date[10] , 2 , ((msb_time & 0x07)<<3) + (lsb_time>>5) );

	// b擾
	fat_translate_number_to_ascii( &sz_date[12] , 2 , (lsb_time & 0x1F)<<1 );
	if( 99 < u8_ms )
	{
		// 1bǉ
		fat_translate_number_to_ascii( &sz_date[12] , 2 , 1 );
		u8_ms -= 100;
	}

	// ms擾
	fat_translate_number_to_ascii( &sz_date[14] , 2 , u8_ms );
}

//! ̊֐ިِlASCIIlɕϊ܂B
//!
//! @param	sz_ascii_number			邽߂ASCII(:"1907")
//! @param	u8_size_number_ascii	(:4)
//! @param	u8_nb_increment			ǉ鐔l(:"102")
//!
//! @verbatim
//! OUT		sz_ascii_numberXV(:"2009")
//! @endverbatim
//!
void fat_translate_number_to_ascii (FS_STRING sz_ascii_number, U8 u8_size_number_ascii, U8 u8_nb_increment)
{
	FS_STRING ptr_sz_ascii_number;

	u8_size_number_ascii--;

	for( ; u8_nb_increment != 0 ; u8_nb_increment-- )
	{
		ptr_sz_ascii_number = sz_ascii_number + u8_size_number_ascii;
		ptr_sz_ascii_number[0]++;
		while( ('9'+1) == *ptr_sz_ascii_number )
		{
			*ptr_sz_ascii_number = '0';
			ptr_sz_ascii_number--;
			ptr_sz_ascii_number[0]++;
		}
	}
}

#if (FSFEATURE_WRITE_COMPLET == (FS_LEVEL_FEATURES & FSFEATURE_WRITE_COMPLET))
//! ̊֐͓tύX܂B
//!
//! @param	type_date	ẗI(FS_DATE_LAST_WRITE܂FS_DATE_CREATION)
//! @param	sz_date		t\<br>
//!						i[`(ASCII)="YYYYMMDDHHMMSSMS"=N,,,,,b,ms
//!
//! @verbatim
//! OUT		Vt¾ XV
//! @endverbatim
//!
void fat_set_date (const FS_STRING sz_date, Bool type_date)
{
	PTR_CACHE ptr_entry;

	fat_cache_mark_sector_as_dirty();
	ptr_entry = fat_get_ptr_entry();

	if( FS_DATE_LAST_WRITE == type_date )
	{
		fat_translatedate_ascii_to_number( sz_date , &ptr_entry[22] , FALSE );
	}
	else
	{
		fat_translatedate_ascii_to_number( sz_date , &ptr_entry[13] , TRUE );
	}
}

//! ̊֐͓tASCIItFATlɕϊ܂B
//!
//! @param	sz_date		t\<br>
//!						i[`(ASCII)="YYYYMMDDHHMMSSMS"=N,,,,,b,ms
//! @param	ptr_date	̓t߲
//! @param	enable_ms	TRUE	ms̈ϊ
//!
//! @verbatim
//! OUT		ptr_dateł̓ẗ揑
//! @endverbatim
//!
void fat_translatedate_ascii_to_number (const FS_STRING sz_date, PTR_CACHE ptr_date, Bool enable_ms)
{
	U8 u8_tmp;
	U8 msb_date, lsb_date, msb_time, lsb_time;

	// Nݒ
	msb_date  = ((U8)(fat_translate_ascii_to_number( sz_date , 4 )-1980))<<1;

	// ݒ
	u8_tmp    = (U8)fat_translate_ascii_to_number( &sz_date[4] , 2 );
	msb_date |= (u8_tmp >> 3);
	lsb_date  = (u8_tmp << 5);

	// ݒ
	lsb_date |= (U8)fat_translate_ascii_to_number( &sz_date[6] , 2 );

	// ݒ
	msb_time  = ((U8)fat_translate_ascii_to_number( &sz_date[8] , 2 )) << (11-8);

	// ݒ
	u8_tmp    = (U8)fat_translate_ascii_to_number( &sz_date[10] , 2 );
	msb_time |= (u8_tmp >> 3);
	lsb_time  = (u8_tmp << 5);

	// bݒ
	u8_tmp    = (U8)fat_translate_ascii_to_number( &sz_date[12] , 2 );
	lsb_time |= (u8_tmp >> 1);

	// msݒ
	if( enable_ms )
	{
		// b̎Ԃ
		if( u8_tmp & 0x01 )
		{	// ŁA
			u8_tmp = 100;					// 1bǉ
		}
		else
		{
			u8_tmp = 0;						// ȏbȂ
		}
		*ptr_date = u8_tmp + (U8)fat_translate_ascii_to_number( &sz_date[14] , 2 );
		ptr_date++;
	}

	// lL^
	ptr_date[0] = lsb_time;
	ptr_date[1] = msb_time;
	ptr_date[2] = lsb_date;
	ptr_date[3] = msb_date;
}

//! ̊֐ASCIIl޼ِlɕϊ܂B
//!
//! @param	sz_ascii_number			ASCIIl(:"1907")
//! @param	u8_size_number_ascii	(:4)
//!
//! @return	޼ِl
//!
//! @verbatim
//! OUT		sz_ascii_numberXV
//! @endverbatim
//!
U16 fat_translate_ascii_to_number (const FS_STRING sz_ascii_number, U8 u8_size_number_ascii)
{
	U8 sz_ascii_number_copy[4];
	U8 _MEM_TYPE_FAST_ *ptr_sz_ascii_number;
	U8 u8_i;
	U16 u16_number;

	for( u8_i=0; u8_i < u8_size_number_ascii; u8_i++ )
	{
		sz_ascii_number_copy[u8_i] = sz_ascii_number[u8_i];
	}

	u16_number=0;

	while( 1 )
	{
		// ASCIIl̍Ō(="0...0")
		ptr_sz_ascii_number = sz_ascii_number_copy;
		for( u8_i = u8_size_number_ascii; u8_i !=0; u8_i-- )
		{
			if( '0' != *ptr_sz_ascii_number )
			{
				break;
			}
			ptr_sz_ascii_number++;
		}
		if( 0 == u8_i)
			return u16_number;

		// l
		ptr_sz_ascii_number = sz_ascii_number_copy + u8_size_number_ascii -1;
		u16_number++;
		ptr_sz_ascii_number[0]--;
		while( ('0'-1) == ptr_sz_ascii_number[0] )
		{
			*ptr_sz_ascii_number = '9';
			ptr_sz_ascii_number--;
			ptr_sz_ascii_number[0]--;
		}
	}
}
#endif // FS_LEVEL_FEATURES

#if (FSFEATURE_WRITE == (FS_LEVEL_FEATURES & FSFEATURE_WRITE))
//! ̊֐͐VŒZOƒO쐬܂B
//!
//! @param	sz_name	쐬閼O(ASCII܂UNICODE)
//!
//! @return	FALSE	ُ̏ꍇA葽ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! IN:
//! b_unicodeUNICODE܂ASCIIIS׸ނłB
//! ONULLɂďI[Ȃ΂Ȃ炸A2'.'Ƃł܂B
//! @endverbatim
//!
Bool fat_create_entry_file_name (FS_STRING sz_name)
{
	U8 u8_i, u8_nb;
	U8 u8_crc, u8_nb_entry;

	// ̖Oɑ΂vZ
	u8_nb_entry = fat_check_name( sz_name  );
	if( 0 == u8_nb_entry )
		return FALSE;

	// ŗL̒Z
	u8_nb = fat_find_short_entry_name( sz_name  );
	if( 0 == u8_nb )
	{
		fs_g_status = FS_ERR_FILE_EXIST;
		return FALSE;						// SĂ̒ZO
	}

	// ɑ΂ċԂ蓖
	if( !fat_alloc_entry_free( u8_nb_entry ))
		return FALSE;
	// :œ߲͐V蓖ĂꂽԂ̍Ō̋󂫓łB

	// ZO̓ǉ
	u8_crc = fat_create_short_entry_name( sz_name , 0 , u8_nb, FALSE  );
	u8_nb_entry--;

	// eO̓ɑ΂
	for( u8_i=1 ; u8_i<=u8_nb_entry ; u8_i++ )
	{
		// O̓֍s
		fs_g_nav_fast.u16_entry_pos_sel_file--;
		if( !fat_read_dir())
			return FALSE;
		// O̓
		if( u8_i == u8_nb_entry )
		{
			u8_i += FS_ENTRY_LFN_LAST;
		}
		fat_create_long_name_entry( sz_name , u8_crc , u8_i );
		sz_name += FS_SIZE_LFN_ENTRY*(Is_unicode? 2 : 1 );
	}
	// ZO̓ɖ߂
	fs_g_nav_fast.u16_entry_pos_sel_file += u8_nb_entry;
	return TRUE;
}

//! ̊֐͒O̓쐬܂B
//!
//! @param	sz_name	쐬閼O(ASCII܂UNICODE)
//! @param	u8_crc	ZOɑΉCRC
//! @param	u8_id	ԍ(n+FS_ENTRY_LFN_LAST̂߂1)
//!
//! @verbatim
//! OUT		VOł̓ ̓XV
//! @endverbatim
//!
void fat_create_long_name_entry (FS_STRING sz_name, U8 u8_crc, U8 u8_id)
{
	PTR_CACHE ptr_entry;
	Bool b_end_of_name = FALSE;

	fat_cache_mark_sector_as_dirty();
	ptr_entry = fat_get_ptr_entry();
	*ptr_entry = u8_id;
	ptr_entry++;							// O̧ٓ̕ψ1n܂܂B

	for( u8_id=1; u8_id<FS_SIZE_FILE_ENTRY ; u8_id++ , ptr_entry++ )
	{
		// Ȃ̈
		if( 11 == u8_id)
		{
			*ptr_entry = FS_ATTR_LFN_ENTRY;	// ̈
			continue;
		}
		if( (12 == u8_id)
		 || (26 == u8_id)
		 || (27 == u8_id) )
		{
			// \̈
//			*ptr_entry = 0x00;				// YɂȂ΂ȂȂ߁Asv
			continue;
		}
		if( 13 == u8_id)
		{
			*ptr_entry = u8_crc;			// CRC̈
			continue;
		}

		// ̈
		if( !b_end_of_name )
		{
			U16 u16_tmp;
			if( Is_unicode )
			{
				u16_tmp = ((FS_STR_UNICODE)sz_name)[0];
			}else{
				u16_tmp = sz_name[0];
			}
			if(('\\' == u16_tmp )
			|| ('/'  == u16_tmp ) )
			{	// ȌI
				u16_tmp = 0;				// ȌI׸ސݒ
			}
			if( 0 == u16_tmp )
			{
				b_end_of_name = TRUE;
			}
			*ptr_entry = LSB(u16_tmp);
			ptr_entry++;
			*ptr_entry = MSB(u16_tmp);
			u8_id++;
			sz_name += (Is_unicode? 2 : 1 );
		}
		else
		{	// ȌI
			*ptr_entry = 0xFF;				// ߕK{
		}
	} // JԂI
}

//! ̊֐͓ ܂͕ŒZO쐬܂B
//!
//! @param	sz_name		쐬閼O(ASCII܂UNICODE)
//! @param	short_name	8.3`ł̒ZO(=8+3޲) (mode=TRUȄꍇɂgp)
//! @param	nb			ZOł̒ǉ(:name~nb)
//! @param	mode		TRUE	ŏ<br>
//!						FALSE	ŏ
//!
//! @return	ZOCRC
//!
U8 fat_create_short_entry_name (FS_STRING sz_name, FS_STRING short_name, U8 nb, Bool mode)
{
	PTR_CACHE ptr_entry = 0;
	U8 u8_i, u8_step, character;
	U8 crc;
	U8 nb_digit;

	if( !mode )
	{
		// ݂̓ŒZO̓쐬邽߂ɓύX
		fat_cache_mark_sector_as_dirty();
		// ݂߲̓擾
		ptr_entry = fat_get_ptr_entry();
	}

	// ޼ِlvZ
	if( nb < 10 )        nb_digit = 1;
	else if( nb < 100 )  nb_digit = 2;
	else                 nb_digit = 3;

	crc = u8_i = 0;
	u8_step = 1;
	while( 1 )
	{
		if( Is_unicode )
		{
			character = ((FS_STR_UNICODE)sz_name)[0];
		}else{
			character = sz_name[0];
		}

		if( 1 == u8_step )
		{	// 1iK=Oϊ
			if( ((FS_SIZE_SFNAME_WITHOUT_EXT-(1+nb_digit)) == u8_i)		// Ö斞t("~1"ɑ΂-2)
			||  ('.'    == character)		// gqȂł̖O̍Ō
			||  fat_check_eof_name(character))	// O̍Ō
			{
				u8_step++;					// ̒iK
				continue;
			}
		}
		if( 8 == u8_step )
		{	// 8iK=gqϊ
			if( (u8_i == FS_SIZE_SFNAME)	// Ö斞t
			||  fat_check_eof_name(character))	// O̍Ō
			{
				u8_step++;					// ̒iK
				continue;
			}
		}
		if( (1==u8_step) || (8==u8_step) )
		{	// Oϊ̂߂̒iK
			character = fat_translate_char_shortname( character );
			sz_name += (Is_unicode? 2 : 1 );
			if( 0 == character )
			{
				continue;					// sA͖
			}
		}
		if( 7 == u8_step )
		{	// 7iK='.'T
			if( ('.'    == character)		// gqȂł̖O̍Ō
			||  fat_check_eof_name(character))	// O̍Ō
			{
				u8_step++;					// ̒iK
			} else {
				sz_name += (Is_unicode? 2 : 1 );
			}
			continue;						// ̒iK͒ZOŕǉ܂B
		}
		if( 6 == u8_step )
		{	// 6iK=ߒǉ
			if( u8_i == FS_SIZE_SFNAME_WITHOUT_EXT )	// gqȂł̖Ö̍Ō
			{
				u8_step++;					// ̒iK
				continue;
			}
			character = ' ';
		}
		if( 9 == u8_step )
		{	// 9iK=gqŌߒǉ
			if( u8_i == FS_SIZE_SFNAME )	// gqtÖ̍Ō
			{
				break;						// while(1)JԂI
			}
			character = ' ';
		}
		if( 5 == u8_step )
		{	// 5iK=ԍ1̌ǉ
			character = '0'+(nb%10);
			u8_step++;						// ̒iK
		}
		if( 4 == u8_step )
		{	// 4iK=ԍ10̌ǉ
			character = '0'+((nb%100)/10);
			u8_step++;						// ̒iK
		}
		if( 3 == u8_step )
		{	// 3iK=ԍ100̌ǉ
			character = '0'+(nb/100);
			u8_step++;						// ̒iK
		}
		if( 2 == u8_step )
		{	// 2iK='~'ǉ
			character = '~';
			u8_step+=(4-nb_digit);			// ̒iK
		}

		if( mode )
		{
			// ɏՕɒZOL^
			*short_name = character;
			short_name++;
		}else{
			// Z̧ٓɕL^
			*ptr_entry = character;
			ptr_entry++;
		}
		u8_i++;

		// ZOCRCvZ
		crc = (crc >> 1) + ((crc & 1) << 7);	// ]
		crc += character;					// ̕Z
	} // whileJԂ̏I
	return crc;
}

//! ̊֐͌ŗL̒ZO܂B
//!
//! @param	sz_name	X̖O
//!
//! @return	ZO쐬Ɏgpԍ
//! @return	0	ُ̏ꍇ
//!
U8 fat_find_short_entry_name (FS_STRING sz_name)
{
	char _MEM_TYPE_SLOW_ short_name[11];
	U8 u8_nb;

	u8_nb = 0;
	while(1)
	{
		if( 0xFF == u8_nb )
			return 0;						// SĂ̒ZO

		u8_nb++;							// ̒ZOs
		fat_create_short_entry_name( sz_name , short_name , u8_nb , TRUE  );	// ZOvZ
		fs_g_nav_fast.u16_entry_pos_sel_file = 0;	// ިڸ؂̎n߂֍s
		// Z邽߂ިڸؑ
		while(1)
		{
			if ( !fat_read_dir())			// ިڸؓǂݍ
			{
				if( FS_ERR_OUT_LIST == fs_g_status )
					return u8_nb;			// ZOs݁Aǂԍ
				return 0;					// т܂ިُ̈
			}
			if( fat_entry_shortname_compare( short_name ) )	// 
				break;						// ZO
			if( FS_ERR_ENTRY_EMPTY == fs_g_status )
				return u8_nb;				// ZOs݁Aǂԍ
			fs_g_nav_fast.u16_entry_pos_sel_file++;			// ̓֍s
		}
	}
}

//! ̊֐͒ZO݂̓Ɣr܂B
//!
//! @param	short_name	rZO(`=8+3޲)
//!
//! @return	TRUE		
//! @return	FALSE		ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//!
Bool fat_entry_shortname_compare (FS_STRING short_name)
{
	PTR_CACHE ptr_entry;

	ptr_entry = fat_get_ptr_entry();
	if( FS_ENTRY_END == *ptr_entry )		// ިڸ؂̏I
	{
		fs_g_status = FS_ERR_ENTRY_EMPTY;
		return FALSE;
	}
	if( (FS_ENTRY_DEL == *ptr_entry )		// 폜ꂽ
	 || (FS_ATTR_LFN_ENTRY == ptr_entry[11]) )	// ̧ٖ
	{
		fs_g_status = FS_ERR_ENTRY_BAD;
		return FALSE;
	}
	fs_g_status = FS_ERR_ENTRY_BAD;			// ɂĂ͈̓ႤA
	return (0==memcmp_ram2ram(ptr_entry , short_name , 8+3 ));
}

//! ̧ٖŎxȂ̕\
_CONST_TYPE_ U8 fs_s_tab_incorrect_char[]={':','*','?','"','<','>','|'};

//! ̊֐͖O̕𒲂ׁAOi[邽߂̧ٓvZ܂B
//!
//! @param	sz_name	쐬錳̖O
//!
//! @return	Oi[邽߂̧ٓ(ZO+O)<br>
//!			sȖȌꍇ0Ԃ܂B
//!
U8 fat_check_name (FS_STRING sz_name)
{
	U8 u8_nb_entry, u8_i, u8_j;
	U16 u16_character;

	u8_nb_entry = 2;						// ŒAZ+1̒
	u8_i = FS_SIZE_LFN_ENTRY;
	while( 1 )
	{
		if( Is_unicode )
		{
			u16_character = ((FS_STR_UNICODE)sz_name)[0];
		}else{
			u16_character = sz_name[0];
		}
		if( fat_check_eof_name( u16_character ) )
			break;

		for( u8_j = 0 ; u8_j < sizeof(fs_s_tab_incorrect_char) ; u8_j++ )
		{
			if( u16_character == fs_s_tab_incorrect_char[u8_j] )
			{
				fs_g_status = FS_ERR_INCORRECT_NAME;
				return 0;					// sȕ
			}
		}
		if( 0 == u8_i )
		{
			u8_nb_entry++;
			u8_i = FS_SIZE_LFN_ENTRY;
		}
		u8_i--;
		sz_name += (Is_unicode? 2 : 1 );
	}
	if( 0x14 < u8_nb_entry )
	{
		fs_g_status = FS_ERR_NAME_TOO_LARGE;
		return 0;							// 傫閼O
	}
	return u8_nb_entry;
}

//! ZOŎxȂ̕\
_CONST_TYPE_ U8 fs_s_execption_char[]={'+',',','.',';','=','[',']'};

//! ̊֐͒ZO̕F؂邽߂ɕϊ܂B
//!
//! @param	character	ϊ镶
//!
//! @return	ϊꂽ<br>
//!			xȂꍇ0
//!
U8 fat_translate_char_shortname (U8 character)
{
	U8 u8_j;

	if( (character<=' ') || ('~'<character) )
		return 0;
	if( ('a'<=character) && (character<='z') )
	{
		return (character - ('a'-'A'));		// 啶ɕϊ
	}
	for( u8_j = 0 ; u8_j < sizeof(fs_s_execption_char) ; u8_j++ )
	{
		if( character == fs_s_execption_char[u8_j] )
			return 0;
	}
	return character;
}

//! ̊֐݂͌ިڸ؂ɓ蓖Ă܂B
//!
//! @param	u8_nb_entry	蓖Ă
//!
//! @return	FALSE		ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE		̑
//!
//! @verbatim
//! OUT		ŌɊ蓖Ăꂽ󂫓żт
//! @endverbatim
//!
Bool fat_alloc_entry_free (U8 u8_nb_entry)
{
	PTR_CACHE ptr_entry;
	Bool b_garbage_collector_used = FALSE;
	U8 u8_nb_entry_save;

	u8_nb_entry_save = u8_nb_entry;

	// ިڸ؂̎n߂ŊJn
	fs_g_nav_fast.u16_entry_pos_sel_file=0;
	// ިڸؓJԂ
	while( 1 )
	{
		// ިڸ؂̾œ𖞂B
		if( !fat_read_dir() )
		{
			if( FS_ERR_OUT_LIST != fs_g_status )
				return FALSE;

			// ʒu׽ꗗ̊OŁAV蓖(=VK׽)
			// :fs_g_seg.u32_addr͐Vꗗƌq߂ިڸ؈ꗗ̸׽l܂݂܂B
			fs_g_seg.u32_size_or_pos = 1;
			if( !fat_allocfreespace())
			{
				// ̧ٓŒfА
				if( b_garbage_collector_used )
					return FALSE;
				if( !fat_garbage_collector_entry())
					return FALSE;
				b_garbage_collector_used = TRUE;
				fs_g_nav_fast.u16_entry_pos_sel_file=0;
				u8_nb_entry = u8_nb_entry_save;
				continue;
			}

			// ̐VK׽YɂB
			// :fs_g_seg.u32_addr͐V׽l܂݂܂B
			if( !fat_clear_cluster())
				return FALSE;

			continue;						// V蓖ĂꂽT߂ިڸ؈ꗗđ
		}

		// 
		ptr_entry = fat_get_ptr_entry();
		if ( FS_ENTRY_END == *ptr_entry )
		{	// ̓͋
			u8_nb_entry--;
			if( 0 == u8_nb_entry )
			{
				return TRUE;				// SĂ̋󂫓
			}
		}

		// ̓֍sB
		fs_g_nav_fast.u16_entry_pos_sel_file++;
		if( 0 == fs_g_nav_fast.u16_entry_pos_sel_file )
		{
			// ŁAިڸ؂͍őeʂ܂B
			// ̧ٓŒfА
			if( b_garbage_collector_used )
			{
				// ިڸؖt(65535̂߂FATWިڸ)
				fs_g_status = FS_ERR_NO_FREE_SPACE;
				return FALSE;
			}
			if( !fat_garbage_collector_entry())
				return FALSE;
			b_garbage_collector_used = TRUE;
			fs_g_nav_fast.u16_entry_pos_sel_file=0;
			u8_nb_entry = u8_nb_entry_save;
			continue;
		}
	} // while(1)I
}

//! ̊֐͂Yɂ邽߂ިڸؓ̍폜ꂽ苎܂B
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
Bool fat_garbage_collector_entry (void)
{
	_MEM_TYPE_SLOW_ U8 entry[ FS_SIZE_FILE_ENTRY ];
	PTR_CACHE ptr_entry;
	U16 u16_pos_old = 0;
	U16 u16_pos_new = 0;

	// ިڸؓJԂ
	while( 1 )
	{
		// ꗗ֍s
		fs_g_nav_fast.u16_entry_pos_sel_file=u16_pos_old;
		// ިڸ؂̾œ𖞂B
		if( !fat_read_dir() )
		{
			if( FS_ERR_OUT_LIST != fs_g_status )
				return FALSE;
			goto fat_garbage_collector_entry_endofdir;
		}

		// 
		ptr_entry = fat_get_ptr_entry();

		if ( FS_ENTRY_END == *ptr_entry )
		{
			// 󂫂ȂAꗗ̍Ō
fat_garbage_collector_entry_endofdir:
			// ꗗ̋𖞂B
			fs_g_nav_fast.u16_entry_pos_sel_file=u16_pos_new;
			while( fs_g_nav_fast.u16_entry_pos_sel_file != u16_pos_old )
			{
				// ިڸ؂̾œ𖞂B
				if( !fat_read_dir() )
					return FALSE;
				memset( fat_get_ptr_entry() , 0 , 32 );
				fat_cache_mark_sector_as_dirty();
				fs_g_nav_fast.u16_entry_pos_sel_file++;
			}
			return TRUE;					// fЏI
		}

		if ( FS_ENTRY_DEL != *ptr_entry )
		{
			// L
			if( u16_pos_old != u16_pos_new )
			{
				// 󂫋ԑ݂ȂAړ
				memcpy_ram2ram( entry, ptr_entry, FS_SIZE_FILE_ENTRY );
				fs_g_nav_fast.u16_entry_pos_sel_file=u16_pos_new;
				// ިڸ؂̾œ𖞂B
				if( !fat_read_dir() )
					return FALSE;
				memcpy_ram2ram( fat_get_ptr_entry(), entry, FS_SIZE_FILE_ENTRY );
				fat_cache_mark_sector_as_dirty();
			}
			u16_pos_new++;
		}
		u16_pos_old++;
	} // while(1)I
}

//! ̊֐̧ٓƸ׽ꗗ폜܂B
//!
//! @param	b_cluster_list	TRUE	̧ٓƸ׽ꗗ폜
//!							FALSE	̧ٓ폜
//!
//! @return	FALSE			ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE			̑
//!
Bool fat_delete_file (Bool b_cluster_list)
{
	PTR_CACHE ptr_entry;
	U8 u8_tmp;
	Bool b_short_del = FALSE;

	// ިڸؓJԂ
	while( 1 )
	{
		// ިڸ؂̾œ𖞂B
		if( !fat_read_dir() )
			return FALSE;

		// ݂߲̓擾
		ptr_entry = fat_get_ptr_entry();
		u8_tmp = ptr_entry[0];

		if( (FS_ATTR_LFN_ENTRY != ptr_entry[11])
		 && (b_short_del) )
		{
			// s݂ȂAZ폜
			break;							// ׽ꗗ폜֍s
		}

		// 폜
		b_short_del = TRUE;
		ptr_entry[0] = FS_ENTRY_DEL;
		fat_cache_mark_sector_as_dirty();

		if( (FS_ATTR_LFN_ENTRY == ptr_entry[11])
		 && ( 0 != (FS_ENTRY_LFN_LAST & u8_tmp)) )
		{
			// O̍Ō̓
			break;							// ׽ꗗ폜֍s
		}

		// O̓֍sB
		fs_g_nav_fast.u16_entry_pos_sel_file--;
	} // while(1)I

	if( b_cluster_list )
	{
		// ׽ꗗ폜
		fs_g_nav_entry.u32_pos_in_file=0;	// (n܂ŊJn)SĂ̈ꗗ폜
		if( !fat_read_file( FS_CLUST_ACT_CLR ))
			return FALSE;
	}

	return TRUE;
}
#endif // FS_LEVEL_FEATURES

//! ̊֐߰èݓ̋󂫋ԂԂ܂B
//!
//! @return	󂫋Ԃ̔ԍ<br>
//!			0̏ꍇAُ܂͖t
//!
U32 fat_getfreespace (void)
{
	U32 u32_nb_free_cluster = 0;

	// SĂFAT 1ǂݍ
	fs_g_cluster.u32_pos = 2;

	if( Is_fat12 )
	{	// FAT12̂
		for(
		;     fs_g_cluster.u32_pos < fs_g_nav.u32_CountofCluster
		;     fs_g_cluster.u32_pos++ )
		{
			// ׽̒l擾
			if ( !fat_cluster_val( FS_CLUST_VAL_READ ) )
				return 0;

			if ( 0 == fs_g_cluster.u32_val )
				u32_nb_free_cluster++;
		}
	}
	else
	{
		if( Is_fat32 )
		{
			u32_nb_free_cluster = fat_read_fat32_FSInfo();
			if( 0xFFFFFFFF != u32_nb_free_cluster )
				goto endof_fat_getfreespace;
			u32_nb_free_cluster = 0;
		}
		// FAT16FAT32ɑ΂Ă̑xœK
		// fat_cluster_readnext()ɂĎgpŏ̒l
		if( !fat_cluster_val( FS_CLUST_VAL_READ ))
			return FALSE;
		for(
		;     fs_g_cluster.u32_pos < fs_g_nav.u32_CountofCluster
		;     fs_g_cluster.u32_pos++ )
		{
			if ( 0 == fs_g_cluster.u32_val )
				u32_nb_free_cluster++;
			if( !fat_cluster_readnext() )
				return FALSE;
		}
#if (FSFEATURE_WRITE_COMPLET == (FS_LEVEL_FEATURES & FSFEATURE_WRITE_COMPLET) )
		if( Is_fat32 )
		{
			// ̌Ăяoɑ΂lۑ
			fat_write_fat32_FSInfo( u32_nb_free_cluster );
		}
#endif
	}
endof_fat_getfreespace:
	return (u32_nb_free_cluster * fs_g_nav.u8_BPB_SecPerClus);
}

//! ̊֐%ŋ󂫋ԂԂ܂B
//!
//! @return	󂫋Ԃ%(1`100)
//!			0̏ꍇُ͈܂͖t
//!
//! @verbatim
//! fat_getfreespace()ٰ݂łA1%̌덷łB
//! @endverbatim
//!
U8 fat_getfreespace_percent (void)
{
	U32 u32_nb_free_cluster = 0;
	U16 u16_tmp, u16_pos;

	if( Is_fat12 )
	{	// FAT12ł̑xœK̕KvȂ
		return (((fat_getfreespace()/fs_g_nav.u8_BPB_SecPerClus)*100) / fs_g_nav.u32_CountofCluster);
	}

	fs_g_cluster.u32_pos = 2;
	// fat_cluster_readnext()ɂĎgpŏ̒l
	if( !fat_cluster_val( FS_CLUST_VAL_READ ))
		return FALSE;

	// œK͈ȉɑ΂
	// - ׽LSB޲ēǂݍ݂̂
	// - 2̸׽ɑ΂1̸׽ǂݍ݂̂
	if( Is_fat32 )
	{
		u32_nb_free_cluster = fat_read_fat32_FSInfo();
		if( 0xFFFFFFFF != u32_nb_free_cluster )
			goto endof_fat_getfreespace_percent;
		u32_nb_free_cluster = 0;

		u16_pos = 2*4;
		for(  u16_tmp = fs_g_nav.u16_fat_size
		;     u16_tmp!=0
		;     u16_tmp-- )
		{
			for( ; u16_pos < 512 ; u16_pos += (2*4) )
			{
				if( 0 == fs_g_sector[u16_pos] )
					u32_nb_free_cluster+=2;
			}
			// FAT̎̾ǂݍ
			u16_pos = 0;
			fs_gu32_addrsector++;
			if( !fat_cache_read_sector( TRUE ))
				return 0;
		}
	}

	if ( Is_fat16 )
	{
		u16_pos = 2*2;

		for(  u16_tmp = fs_g_nav.u16_fat_size
		;     u16_tmp!=0
		;     u16_tmp-- )
		{
			for( ; u16_pos < 512 ; u16_pos += (2*2) )
			{
				if( 0 == fs_g_sector[u16_pos] )
					u32_nb_free_cluster+=2;
			}
			// FAT̎̾ǂݍ
			u16_pos = 0;
			fs_gu32_addrsector++;
			if( !fat_cache_read_sector( TRUE ))
				return 0;
		}
	}

	// %vZ
	if( u32_nb_free_cluster > fs_g_nav.u32_CountofCluster )
		return 100;
	if( u32_nb_free_cluster > ((fs_g_nav.u32_CountofCluster-u32_nb_free_cluster)/256) )
	{
		// 덷̌vZƒǉ
		u32_nb_free_cluster -= ((fs_g_nav.u32_CountofCluster-u32_nb_free_cluster)/256);
	}
endof_fat_getfreespace_percent:
	return ((u32_nb_free_cluster * 100) / fs_g_nav.u32_CountofCluster);
}

#if (FSFEATURE_WRITE == (FS_LEVEL_FEATURES & FSFEATURE_WRITE))
//! ̊֐͸׽ꗗ蓖Ă܂B
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_seg.u32_addr			V׽ꗗƌq߂̸ꗗ̍Ō̸׽l
//!								q׽ꗗȂ̏ꍇAMSB0(fs_g_seg.u32_addr)0xFFɐݒ肵ĂB
//!   fs_g_seg.u32_size_or_pos	蓖Ă׽ꗗ̍őe(P)
//! OUT:
//!   fs_g_seg.u32_addr			V׽ꗗ̍ŏ̸׽l
//!   fs_g_seg.u32_size_or_pos	c辸(ިfЉ܂ިt̂߁A蓖ĂĂȂ)
//! @endverbatim
//!
Bool fat_allocfreespace (void)
{
	// Vꗗ̍ŏ̋󂫸׽ŏ̒iK}邽߂׸
	Bool first_cluster_free_is_found = FALSE;
	// TRUEȂAv菇gp܂ASĂFAT𑖍AȂΒᑬ菇gp܂ASFAT𑖍܂B
	Bool b_quick_find = TRUE;

	if( Is_fat32 )
	{
		// 󂫋ԂɂĂ̏
		if( !fat_write_fat32_FSInfo( 0xFFFFFFFF ))
			return FALSE;
	}

	if( 0xFF == MSB0(fs_g_seg.u32_addr) )
	{
fat_allocfreespace_start:
		// V׽ꗗȂAFAT̎n߂Č
		fs_g_cluster.u32_pos = 2;
	}else{
		// ׽ꗗpȂA׽ꗗ̍Ō̌ŊJn
		fs_g_cluster.u32_pos = fs_g_seg.u32_addr+1;
	}

	fat_clear_info_fat_mod();

	// SFAT1ǂݍ
	for(
	;     fs_g_cluster.u32_pos < fs_g_nav.u32_CountofCluster
	;     fs_g_cluster.u32_pos++ )
	{
		// ׽̒l擾
		if ( !fat_cluster_val( FS_CLUST_VAL_READ ) )
			return FALSE;

		if ( 0 == fs_g_cluster.u32_val )
		{
			// 󂫸׽
			fs_g_cluster.u32_val = fs_g_cluster.u32_pos;	// ׽̒l͐V󂫸׽
			if( TRUE == first_cluster_free_is_found )
			{
				// V׽O̸׽ɌqB
				fs_g_cluster.u32_pos--;		// O̸׽I
				if ( !fat_cluster_val( FS_CLUST_VAL_WRITE ) )
					return FALSE;
			}
			else
			{
				// Vꗗ̍ŏ̸׽
				first_cluster_free_is_found = TRUE;

				if( 0xFF != MSB0(fs_g_seg.u32_addr) )
				{
					// ̐V׽̸݂׽ꗗɌqB
					// ݂̈ꗗ̍Ō̸׽I
					if( 0 == fs_g_seg.u32_addr )
					{	// ̸݂׽ꗗٰ ިڸ؂̸׽ꗗ
						if( FS_TYPE_FAT_32 != fs_g_nav_fast.u8_type_fat )
						{
							// FAT12܂FAT16ٰ ިڸؗeʑ͕s
							fs_g_status = FS_ERR_NO_FREE_SPACE;
							return FALSE;
						}
						fs_g_cluster.u32_pos = fs_g_nav.rootdir.u32_cluster;
					}
					else
					{
						fs_g_cluster.u32_pos = fs_g_seg.u32_addr;
					}
					if ( !fat_cluster_val( FS_CLUST_VAL_WRITE ) )
						return FALSE;
				} // else:̸݂׽ꗗȂ߁AFAT̍ŏ̸׽݂Ȃ
				fs_g_seg.u32_addr = fs_g_cluster.u32_val;	// ŏ̸׽lۑ
			}

			// V׽ʒuŁAꗗI׸ސݒ
			fs_g_cluster.u32_pos = fs_g_cluster.u32_val;	// V׽I
			fs_g_cluster.u32_val = FS_CLUST_VAL_EOL;		// ׽l͈ꗗI׸
			if ( !fat_cluster_val( FS_CLUST_VAL_WRITE ) )
				return FALSE;

			// c辸vZ
			if ( fs_g_seg.u32_size_or_pos <= fs_g_nav.u8_BPB_SecPerClus )
			{
				fs_g_seg.u32_size_or_pos = 0;	// SԔ
				break;						// JԂ~
			}
			fs_g_seg.u32_size_or_pos -= fs_g_nav.u8_BPB_SecPerClus;
		}
		else
		{
			// ̸׽󂫂ł͂ȂB
			if( TRUE == first_cluster_free_is_found )
			{
				// p ؂߂ɁA׽ꗗ͌płȂ΂Ȃ܂B
				// ̌Ɋ蓖Ē~
				break;
			}
			else
			{
				// ŏ̋󂫸׽̂߂̍ŏ̒iKȂA󂫂łȂ̸׽𖳎Čp
				if( b_quick_find )
				{
					fs_g_cluster.u32_pos += 500;
				}
			}
		}
	}

	// 蓖Ă̍Ō
	if( FALSE == first_cluster_free_is_found )
	{
		if( b_quick_find )
		{
			// WőSFATĎs(=vłȂ)
			b_quick_find = FALSE;
			goto fat_allocfreespace_start;
		}
		fs_g_status = FS_ERR_NO_FREE_SPACE;	// 󂫸׽ȂB
		return FALSE;
	}

	return fat_update_fat2();
}
#endif // FS_LEVEL_FEATURES

#if (FS_LEVEL_FEATURES > FSFEATURE_READ)
//! ̊֐FATύXɂĂ̷܂B
//!
void fat_clear_info_fat_mod (void)
{
	fs_g_u16_first_mod_fat = 0xFFFF;
	fs_g_u16_last_mod_fat = 0;
}
#endif // FS_LEVEL_FEATURES

#if (FS_LEVEL_FEATURES > FSFEATURE_READ)
//! ̊֐͍ŏFAT̕ύX2ڂFATɕʂ܂B
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
Bool fat_update_fat2 (void)
{
	while( fs_g_u16_first_mod_fat <= fs_g_u16_last_mod_fat )
	{
		// FAT1̕ύXʒuvZ
		fs_gu32_addrsector = fs_g_nav.u32_ptr_fat + fs_g_u16_first_mod_fat;
		// FAT1ǂݍ
		if( !fat_cache_read_sector( TRUE ))
			return FALSE;
		// FAT2̕ύXʒuvZ
		fs_gu32_addrsector = fs_g_nav.u32_ptr_fat + ((U32)fs_g_u16_first_mod_fat + fs_g_nav.u16_fat_size);
		// FAT2FAT1̒Oŏ
		if( !fat_cache_read_sector( FALSE ))
			return FALSE;
		// FAT2ύX̂悤׸ނ𗧂ĂB
		fat_cache_mark_sector_as_dirty();
		fs_g_u16_first_mod_fat++;
	}
	return TRUE;
}
#endif // FS_LEVEL_FEATURES

#if (FSFEATURE_WRITE == (FS_LEVEL_FEATURES & FSFEATURE_WRITE))
//! ̊֐1׽܂B
//!
//! @return	FALSE	ُ̏ꍇA葽̏ڍׂɂĂ"fs_g_status"SlB
//! @return	TRUE	̑
//!
//! @verbatim
//! gpSϐ
//! IN :
//!   fs_g_seg.u32_addr	׽l
//! @endverbatim
//!
Bool fat_clear_cluster (void)
{
	U8 u8_loop;

	// ׽  ڽvZ
	fs_g_seg.u32_size_or_pos  = 0;			// ׽̎n߂I
	if( !fat_cluster_list( FS_CLUST_ACT_ONE, FALSE ))
		return FALSE;

	// ׽JԂ(׽̍ŌŊJn)
	fs_gu32_addrsector = fs_g_seg.u32_addr + (fs_g_nav.u8_BPB_SecPerClus -1);
	for(  u8_loop = 0
	;     fs_g_nav.u8_BPB_SecPerClus != u8_loop
	;     u8_loop++ )
	{
		// ׽ ōXVA؂ްǂ܂ȂB
		if( !fat_cache_read_sector( FALSE ))
			return FALSE;

		if(0 == u8_loop)
		{	// Yɂ()B(Pɾ̂)
			fat_cache_clear();
		}
		fat_cache_mark_sector_as_dirty();
		fs_gu32_addrsector--;				// O֍s
	}
	return TRUE;
}
#endif // FS_LEVEL_FEATURES
